;
; 01 timer.asm
;
; Created: 2016-11-25
; Author : Wolfgang Neff
;

    .EQU F_CPU=2000000
    .INCLUDE "board.inc"

	; Data Segment
	.DSEG

	; Code Segment
	.CSEG

	; Interrupt Vector Table
	.ORG 0
	rjmp reset
	.ORG TCF1_OVF_vect
	rjmp timer_isr
	.ORG INT_VECTORS_SIZE

reset:
	; Initialize stack
	ldi r16, low(INTERNAL_SRAM_END)
	sts CPU_SPL, r16
	ldi r16, high(INTERNAL_SRAM_END)
	sts CPU_SPH, r16

    ; Initialize LED
	ldi r16, LED0_PIN_bm
    sts LED_PORT_DIRSET, r16
    sts LED_PORT_OUTSET, r16

	; Initialize Timer
	ldi r16, TC_CLKSEL_DIV1024_gc
    sts TCF1_CTRLA, r16
	ldi r16, TC_OVFINTLVL_LO_gc
    sts TCF1_INTCTRLA, r16
	ldi r16, low(976)
	sts TCF1_PER, r16
	ldi r16, high(976)
	sts TCF1_PER+1, r16

	; Low-level interrupt enable
	lds r16, PMIC_CTRL
	ori r16, PMIC_LOLVLEN_bm
	sts PMIC_CTRL, r16

	; Global interrupts enable 
    sei

super_loop:
    rjmp super_loop

;***************************************************************************
;* SUBROUTINES *************************************************************
;***************************************************************************

timer_isr:
	push r16
	in r16, CPU_SREG
	push r16
	ldi r16, LED0_PIN_bm
	sts LED_PORT_OUTTGL, r16
	pop r16
	out CPU_SREG, r16
	pop r16
	reti
