;
; 02 usart.asm
;
; Created: 2017-01-04
; Author : Wolfgang Neff
;

    .EQU F_CPU=2000000
    .INCLUDE "board.inc"

    .EQU BUFFER_FULL=1
    .EQU BUFFER_EMPTY=0

	; Data Segment
	.DSEG
buffer:
    .BYTE 1
status:
    .BYTE 1

	; Code Segment
	.CSEG

	; Interrupt Vector Table
	.ORG 0
	rjmp reset
	.ORG USB_USART_RXC_vect
	rjmp usart_isr
	.ORG INT_VECTORS_SIZE

reset:
	; Initialize data
	ldi r16, BUFFER_EMPTY
	sts status, r16

	; Initialize stack
	ldi r16, low(INTERNAL_SRAM_END)
	sts CPU_SPL, r16
	ldi r16, high(INTERNAL_SRAM_END)
	sts CPU_SPH, r16

    ; Initialize USART pins
	ldi r16, USB_USART_TX_PIN_bm
	sts USB_USART_PORT_DIRSET, r16
	ldi r16, USB_USART_RX_PIN_bm
	sts USB_USART_PORT_DIRCLR, r16

    ; Initialize USART and enable RXC interrupt
	ldi r16, USART_RXCINTLVL_LO_gc
	sts USB_USART_MODULE_CTRLA, r16
	ldi r16, USART_CMODE_ASYNCHRONOUS_gc | USART_CHSIZE_8BIT_gc | USART_PMODE_DISABLED_gc
	sts USB_USART_MODULE_CTRLC, r16
	ldi r16, 11
	sts USB_USART_MODULE_BAUDCTRLA, r16
	ldi r16, -7 << USART_BSCALE_gp
	sts USB_USART_MODULE_BAUDCTRLB, r16
	ldi r16, USART_RXEN_bm | USART_TXEN_bm
	sts USB_USART_MODULE_CTRLB, r16

	; Low-level interrupt enable
	lds r16, PMIC_CTRL
	ori r16, PMIC_LOLVLEN_bm
	sts PMIC_CTRL, r16

	; Global interrupts enable 
    sei

super_loop:
    lds r16, status
	cpi r16, BUFFER_FULL
	brne super_loop
	; Echo received data
loop:
    lds r16, USB_USART_MODULE_STATUS
    sbrs r16, USART_DREIF_bp
    rjmp loop ; loop if data register not empty
	lds r16, buffer
	sts USB_USART_MODULE_DATA, r16
	ldi r16, BUFFER_EMPTY
	sts status, r16
    rjmp super_loop

;***************************************************************************
;* SUBROUTINES *************************************************************
;***************************************************************************

usart_isr:
	push r16
	in r16, CPU_SREG
	push r16

	lds r16, USB_USART_MODULE_DATA
	sts buffer, r16
	ldi r16, BUFFER_FULL
	sts status, r16

	pop r16
	out CPU_SREG, r16
	pop r16
	reti
