;
; 03 port.asm
;
; Created: 2017-01-04
; Author : Wolfgang Neff
;

    .EQU F_CPU=2000000
    .INCLUDE "board.inc"

	; Data Segment
	.DSEG

	; Code Segment
	.CSEG

	; Interrupt Vector Table
	.ORG 0
	rjmp reset
	.ORG PORTD_INT0_vect
	rjmp int0_isr
	.ORG PORTD_INT1_vect
	rjmp int1_isr
	.ORG INT_VECTORS_SIZE

reset:
	; Initialize stack
	ldi r16, low(INTERNAL_SRAM_END)
	sts CPU_SPL, r16
	ldi r16, high(INTERNAL_SRAM_END)
	sts CPU_SPH, r16

    ; Initialize LED
	ldi r16, LED0_PIN_bm
    sts LED_PORT_DIRSET, r16
    sts LED_PORT_OUTSET, r16

    // Initialize push-buttons
	; BUTTON_LOW_PORT.INTCTRL = PORT_INT0LVL_LO_gc | PORT_INT1LVL_LO_gc;    // Enable port interrupt 0 and 1
	ldi r16, PORT_INT0LVL_LO_gc | PORT_INT1LVL_LO_gc
	sts BUTTON_LOW_PORT_INTCTRL, r16
	; BUTTON_LOW_PORT.INT0MASK = BUTTON0_PIN_bm;                            // Pin 0 triggers interrupt 0
	ldi r16, BUTTON0_PIN_bm
	sts BUTTON_LOW_PORT_INT0MASK, r16
	; BUTTON_LOW_PORT.INT1MASK = BUTTON1_PIN_bm;                            // Pin 1 triggers interrupt 1
	ldi r16, BUTTON1_PIN_bm
	sts BUTTON_LOW_PORT_INT1MASK, r16
	; BUTTON_LOW_PORT.PIN0CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc;  // Trigger interrupt on falling edge
	ldi r16, PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc
	sts BUTTON0_PINCTRL, r16
	sts BUTTON1_PINCTRL, r16

	; Low-level interrupt enable
	lds r16, PMIC_CTRL
	ori r16, PMIC_LOLVLEN_bm
	sts PMIC_CTRL, r16

	; Global interrupts enable 
    sei

super_loop:
    ; Nothing to do
    rjmp super_loop

;***************************************************************************
;* SUBROUTINES *************************************************************
;***************************************************************************

int0_isr:
	push r16
	in r16, CPU_SREG
	push r16
	ldi r16, LED0_PIN_bm
	sts LED_PORT_OUTCLR, r16   ; Switch LED on
	pop r16
	out CPU_SREG, r16
	pop r16
	reti

int1_isr:
	push r16
	in r16, CPU_SREG
	push r16
	ldi r16, LED0_PIN_bm
	sts LED_PORT_OUTSET, r16   ; Switch LED off
	pop r16
	out CPU_SREG, r16
	pop r16
	reti
