;
; 04 dma.asm
;
; Created: 2017-01-04 11:05:44
; Author : Wolfgang
;
    #define MSG "This is a somewhat longer message."

    .EQU F_CPU = 2000000
    .INCLUDE "board.inc"
	.INCLUDE "utils.inc"

	; Data Segment
	.DSEG
string:
	.BYTE strlen(MSG)+1

	; Code Segment
	.CSEG

	; Initialize Data
    ldi r16, strlen(MSG)
	ldi YL, low(string)
	ldi YH, high(string)
    ldi ZL, low(message<<1)
    ldi ZH, high(message<<1)
loop:
    lpm r0, Z+
	st Y+, r0
	dec r16
	brne loop
	ldi r16, '\n'
	st Y+, r16

	; Initialize USART
	ldi r16, USB_USART_TX_PIN_bm
	sts USB_USART_PORT_DIRSET, r16
	ldi r16, USART_CMODE_ASYNCHRONOUS_gc | USART_CHSIZE_8BIT_gc | USART_PMODE_DISABLED_gc
	sts USB_USART_MODULE_CTRLC, r16
	ldi r16, 11
	sts USB_USART_MODULE_BAUDCTRLA, r16 
	ldi r16, -7<<USART_BSCALE_gp
	sts USB_USART_MODULE_BAUDCTRLB, r16
	ldi r16, USART_TXEN_bm
	sts USB_USART_MODULE_CTRLB, r16

	; Initialize DMA controller
    lds r16, DMA_CTRL
	ori r16, DMA_ENABLE_bm
	sts DMA_CTRL, r16

    ; Set source address
	ldi r16, low(string)
	sts DMA_CH0_SRCADDR0, r16
	ldi r16, high(string)
	sts DMA_CH0_SRCADDR1, r16
	clr r16
	sts DMA_CH0_SRCADDR2, r16

    ; Set destination address
	ldi r16, low(USB_USART_MODULE_DATA)
	sts DMA_CH0_DESTADDR0, r16
	ldi r16, high(USB_USART_MODULE_DATA)
	sts DMA_CH0_DESTADDR1, r16
	clr r16
	sts DMA_CH0_DESTADDR2, r16

    ; Initialize channel
	; Increment source address and reload source if block has finished
	; Do not modify destination address and do not reload destination if block has finished
	ldi r16, DMA_CH_SRCRELOAD_BLOCK_gc | DMA_CH_SRCDIR_INC_gc | DMA_CH_DESTRELOAD_NONE_gc | DMA_CH_DESTDIR_FIXED_gc
	sts DMA_CH0_ADDRCTRL, r16
	; Burst length is 1 byte and stop after each byte
    lds r16, DMA_CH0_CTRLA
	andi r16, ~DMA_CH_BURSTLEN_gm
	ori r16, DMA_CH_BURSTLEN_1BYTE_gc
	ori r16, DMA_CH_SINGLE_bm
	sts DMA_CH0_CTRLA, r16

	; Set block length
	ldi r16, strlen(MSG)+1
	sts DMA_CH0_TRFCNT, r16
	clr r16
	sts DMA_CH0_TRFCNT+1, r16
	; Set trigger source
	ldi r16, DMA_CH_TRIGSRC_USARTC0_DRE_gc
	sts DMA_CH0_TRIGSRC, r16

super_loop:
	; Start transmission
    lds r16, DMA_CH0_CTRLA
	ori r16, DMA_CH_ENABLE_bm
	sts DMA_CH0_CTRLA, r16
    delay_ms 1000 
    rjmp super_loop

;***************************************************************************
;* CONSTANTS ***************************************************************
;***************************************************************************

message:
    .DB MSG
